'+--------------------------------------------------------------------------+
'|                             Fahrenheit 451                               |
'|                          BassBox OpenGL plugin                           |
'|                                                                          |
'|                              Version 1.00                                |
'+--------------------------------------------------------------------------+
'|                                                                          |
'|                         Author Patrice TERRIER                           |
'|                                                                          |
'|                            copyright(c) 2008                             |
'|                                                                          |
'|                Patrice Terrier http://www.zapsolution.com                |
'|                                                                          |
'+--------------------------------------------------------------------------+
'|                  Project started on : 12-31-2007 (MM-DD-YYYY)            |
'|                        Last revised : 01-05-2008 (MM-DD-YYYY)            |
'+--------------------------------------------------------------------------+
'

#COMPILE DLL "BBP_Fahrenheit.dll"
#INCLUDE "BBPlugin.inc"

%GL_BLEND                       = &H0BE2
%GL_MODELVIEW                   = &H1700
%GL_PROJECTION                  = &H1701
%GL_DEPTH_TEST                  = &H0B71
%GL_SMOOTH                      = &H1D01
%GL_LIGHT0                      = &H4000???
%GL_TRIANGLE_FAN                = &H0006
%GL_DEPTH_BUFFER_BIT            = &H00000100
%GL_COLOR_BUFFER_BIT            = &H00004000
%GL_QUADS                       = &H0007???
%GL_QUAD_STRIP                  = &H0008???
%GL_FRONT                       = &H0404&
%GL_FRONT_AND_BACK              = &H0408???
%GL_AMBIENT_AND_DIFFUSE         = &H1602???
%GL_COLOR_MATERIAL              = &H0B57???
%GL_UNSIGNED_BYTE               = &h1401&
%GL_QUADS                       = &h0007&
%GL_COLOR_BUFFER_BIT            = &h4000&
%GL_DEPTH_BUFFER_BIT            = &h0100&
%GL_MATRIX_MODE                 = &h0BA0&
%GL_PROJECTION                  = &h1701&
%GL_SMOOTH                      = &h1D01&
%GL_SRC_ALPHA                   = &h0302&
%GL_ONE                         = &h0001&
%GL_LINEAR                      = &h2601&
%GL_PERSPECTIVE_CORRECTION_HINT = &h0C50&
%GL_NICEST                      = &h1102&
%GL_TEXTURE_2D                  = &h0DE1&
%GL_TEXTURE_MAG_FILTER          = &h2800&
%GL_TEXTURE_MIN_FILTER          = &h2801&
%GL_LUMINANCE                   = &h1909&
%GL_RGB                         = &H1907
%GL_RGBA                        = &H1908
%GL_TEXTURE                     = &H1702
%GL_LIGHTING                    = &H0B50
%GL_GREATER                     = &H0204
%GL_POSITION                    = &H1203???
%GL_LIGHT_MODEL_TWO_SIDE        = &H0B52???
%GL_NORMALIZE                   = &H0BA1???
%GL_AMBIENT                     = &H1200???
%GL_DIFFUSE                     = &H1201???
%GL_SPECULAR                    = &H1202???
%GL_POSITION                    = &H1203???
%GL_TRUE                        = 1
%GL_FALSE                       = 0
%GLU_SMOOTH                     = 100000
%GL_LESS                        = &H0201
%GL_ONE_MINUS_SRC_ALPHA         = &H0303&
%GL_ALPHA_TEST                  = &H0BC0&
%GL_ALWAYS                      = &H0207&

TYPE RECT
    nLeft AS LONG
    nTop AS LONG
    nRight AS LONG
    nBottom AS LONG
END TYPE

' -- WinAPI useful functions
DECLARE FUNCTION GetTickCount LIB "KERNEL32.DLL" ALIAS "GetTickCount" () AS DWORD
DECLARE FUNCTION GetClientRect LIB "USER32.DLL" ALIAS "GetClientRect" (BYVAL hwnd AS DWORD, lpRect AS RECT) AS LONG

' -- For V-Sync control we need to get address of extensions
DECLARE FUNCTION wglGetProcAddress LIB "opengl32.dll" ALIAS "wglGetProcAddress" (lpStr AS ASCIIZ) AS LONG
' -- Advanced feature to keep vertical sync on
DECLARE FUNCTION prototype_wglSwapIntervalEXT( BYVAL number AS LONG ) AS LONG

DECLARE SUB glColor4ub LIB "OPENGL32.DLL" ALIAS "glColor3ub" (BYVAL red AS BYTE, BYVAL green AS BYTE, BYVAL blue AS BYTE, BYVAL Alpha AS BYTE)
DECLARE SUB glNormal3f LIB "OPENGL32.DLL" ALIAS "glNormal3f" ( BYVAL SINGLE, BYVAL SINGLE, BYVAL SINGLE )
DECLARE SUB gluLookAt LIB "glu32.dll" ALIAS "gluLookAt" (BYVAL eyex#, BYVAL eyey#, BYVAL eyez#, BYVAL centerx#, BYVAL centery#, BYVAL centerz#, BYVAL upx#, BYVAL upy#, BYVAL upz AS DOUBLE)
DECLARE SUB glColorMaterial LIB "OPENGL32.DLL" ALIAS "glColorMaterial" ( BYVAL DWORD, BYVAL DWORD )
DECLARE SUB glEnd LIB "opengl32.dll" ALIAS "glEnd"
DECLARE SUB glLoadIdentity LIB "opengl32.dll" ALIAS "glLoadIdentity"
DECLARE SUB glBegin LIB "opengl32.dll" ALIAS "glBegin" (BYVAL LONG)
DECLARE SUB glClear LIB "opengl32.dll" ALIAS "glClear" (BYVAL DWORD)
DECLARE SUB glEnable LIB "opengl32.dll" ALIAS "glEnable" (BYVAL DWORD)
DECLARE SUB glDisable LIB "opengl32.dll" ALIAS "glDisable" (BYVAL DWORD)
DECLARE SUB glShadeModel LIB "opengl32.dll" ALIAS "glShadeModel" (BYVAL DWORD)
DECLARE SUB glMatrixMode LIB "opengl32.dll" ALIAS "glMatrixMode" (BYVAL DWORD)
DECLARE SUB glHint LIB "opengl32.dll" ALIAS "glHint" (BYVAL DWORD, BYVAL DWORD)
DECLARE SUB glBlendFunc LIB "opengl32.dll" ALIAS "glBlendFunc" (BYVAL LONG, BYVAL LONG)
DECLARE SUB glTexCoord2f LIB "opengl32.dll" ALIAS "glTexCoord2f" (BYVAL SINGLE, BYVAL SINGLE)
DECLARE SUB glVertex3f LIB "opengl32.dll" ALIAS "glVertex3f" (BYVAL SINGLE, BYVAL SINGLE, BYVAL SINGLE)
DECLARE SUB glTranslatef LIB "opengl32.dll" ALIAS "glTranslatef" (BYVAL SINGLE, BYVAL SINGLE, BYVAL SINGLE)
DECLARE SUB glClearColor LIB "opengl32.dll" ALIAS "glClearColor" (BYVAL SINGLE, BYVAL SINGLE, BYVAL SINGLE, BYVAL SINGLE)
DECLARE SUB glGenTextures LIB "opengl32.dll" ALIAS "glGenTextures" (BYVAL DWORD, textures AS ANY)
DECLARE SUB glBindTexture LIB "opengl32.dll" ALIAS "glBindTexture" (BYVAL DWORD, BYVAL DWORD)
DECLARE SUB glTexParameteri LIB "opengl32.dll" ALIAS "glTexParameteri" (BYVAL DWORD, BYVAL DWORD, BYVAL LONG)
DECLARE SUB glTexImage2D LIB "opengl32.dll" ALIAS "glTexImage2D" (BYVAL DWORD, BYVAL LONG, BYVAL LONG, BYVAL LONG, BYVAL LONG, BYVAL LONG, BYVAL DWORD, BYVAL DWORD, npixels AS ANY)
DECLARE SUB glDeleteTextures LIB "opengl32.dll" ALIAS "glDeleteTextures" (BYVAL LONG, textures AS ANY)
DECLARE FUNCTION glGetError LIB "opengl32.dll" ALIAS "glGetError" () AS DWORD
DECLARE FUNCTION wglMakeCurrent LIB "OPENGL32.DLL" ALIAS "wglMakeCurrent" (BYVAL hdc AS DWORD, BYVAL hglrc AS DWORD) AS LONG
DECLARE SUB gluPerspective LIB "glu32.dll" ALIAS "gluPerspective" (BYVAL fovy#, BYVAL aspect#, BYVAL zNear#, BYVAL zFar AS DOUBLE)
DECLARE SUB glRotatef LIB "OPENGL32.DLL" ALIAS "glRotatef" (BYVAL angle AS SINGLE, BYVAL x AS SINGLE, BYVAL y AS SINGLE, BYVAL z AS SINGLE)
DECLARE SUB glDepthFunc LIB "OPENGL32.DLL" ALIAS "glDepthFunc" (BYVAL func AS DWORD)
DECLARE SUB glLightfv LIB "OPENGL32.DLL" ALIAS "glLightfv" ( BYVAL DWORD, BYVAL DWORD, BYREF SINGLE )
DECLARE SUB glLightModeli LIB "OPENGL32.DLL" ALIAS "glLightModeli" ( BYVAL DWORD, BYVAL LONG )
DECLARE SUB glScalef LIB "OPENGL32.DLL" ALIAS "glScalef" ( BYVAL SINGLE, BYVAL SINGLE, BYVAL SINGLE )
DECLARE SUB glMaterialf LIB "OPENGL32.DLL" ALIAS "glMaterialf" ( BYVAL DWORD, BYVAL DWORD, BYVAL SINGLE )
DECLARE SUB glClearDepth LIB "opengl32.dll" ALIAS "glClearDepth" (BYVAL DOUBLE)
DECLARE SUB glDepthMask LIB "OPENGL32.DLL" ALIAS "glDepthMask" ( BYVAL BYTE )
DECLARE SUB glAlphaFunc LIB "OPENGL32.DLL" ALIAS "glAlphaFunc" (BYVAL func AS DWORD, BYVAL ref AS SINGLE)
DECLARE SUB glColor4f LIB "opengl32.dll" ALIAS "glColor4f" (BYVAL SINGLE, BYVAL SINGLE, BYVAL SINGLE, BYVAL SINGLE)
DECLARE SUB glFrustum LIB "opengl32.dll" ALIAS "glFrustum" (BYVAL DOUBLE, BYVAL DOUBLE, BYVAL DOUBLE, BYVAL DOUBLE, BYVAL DOUBLE, BYVAL DOUBLE)
DECLARE SUB glFlush LIB "OPENGL32.DLL" ALIAS "glFlush" ()

DECLARE FUNCTION gluNewQuadric  LIB "glu32.dll" ALIAS "gluNewQuadric"     () AS DWORD
DECLARE SUB gluDeleteQuadric    LIB "glu32.dll" ALIAS "gluDeleteQuadric"  (BYVAL state AS DWORD)
DECLARE SUB gluQuadricNormals   LIB "glu32.dll" ALIAS "gluQuadricNormals" (BYVAL quadObject AS DWORD, BYVAL normals AS DWORD)
DECLARE SUB gluQuadricTexture   LIB "glu32.dll" ALIAS "gluQuadricTexture" (BYVAL quadObject AS DWORD, BYVAL textureCoords AS DWORD)' ANY)
DECLARE SUB gluSphere           LIB "glu32.dll" ALIAS "gluSphere"         (BYVAL qobj AS DWORD, BYVAL radius#, BYVAL slices&, BYVAL stacks AS LONG)
DECLARE SUB gluCylinder         LIB "glu32.dll" ALIAS "gluCylinder"       (BYVAL qobj AS DWORD, BYVAL baseRadius#, BYVAL topRadius#, BYVAL nheight#, BYVAL slices&, BYVAL stacks AS LONG)

GLOBAL gColor() AS LONG
SUB ColorInit()
    DIM gColor(1 TO 33) AS LONG
    gColor(1)  = RGB(32,32,32)
    gColor(2)  = RGB(0,44,233)
    gColor(3)  = RGB(0,67,210)
    gColor(4)  = RGB(0,89,187)
    gColor(5)  = RGB(0,112,164)
    gColor(6)  = RGB(0,135,142)
    gColor(7)  = RGB(0,159,117)
    gColor(8)  = RGB(0,183,88)
    gColor(9)  = RGB(0,207,58)
    gColor(10) = RGB(0,231,29)
    gColor(11) = RGB(26,234,26)
    gColor(12) = RGB(52,237,23)
    gColor(13) = RGB(79,240,20)
    gColor(14) = RGB(105,243,17)
    gColor(15) = RGB(126,245,14)
    gColor(16) = RGB(147,248,11)
    gColor(17) = RGB(168,250,8)
    gColor(18) = RGB(189,253,5)
    gColor(19) = RGB(210,255,2)
    gColor(20) = RGB(233,255,0)
    gColor(21) = RGB(255,255,0)
    gColor(22) = RGB(255,251,0)
    gColor(23) = RGB(255,235,0)
    gColor(24) = RGB(255,215,0)
    gColor(25) = RGB(255,196,0)
    gColor(26) = RGB(255,176,0)
    gColor(27) = RGB(255,156,0)
    gColor(28) = RGB(253,137,0)
    gColor(29) = RGB(255,117,0)
    gColor(30) = RGB(255,97,0)
    gColor(31) = RGB(255,78,0)
    gColor(32) = RGB(255,58,0)
    gColor(33) = RGB(255,0,0)
END SUB

FUNCTION LevelColr(BYVAL nLevel AS LONG) AS LONG
    LOCAL nColor AS LONG
    nLevel = nLevel + 1: IF nLevel > 33 THEN nLevel = 33
    nColor = 0: IF nLevel > 0 THEN nColor = gColor(nLevel)
    FUNCTION = nColor
END FUNCTION

SUB DrawCylinder(BYVAL Radius AS SINGLE, BYVAL Value AS SINGLE, BYVAL R1 AS SINGLE, BYVAL R2 AS SINGLE)
    LOCAL quadObj AS LONG
    quadObj = gluNewQuadric()                        ' Pointer to the Quadric Object (Return 0 If No Memory))
    IF quadObj THEN
       gluQuadricNormals(quadObj, %GLU_SMOOTH)  ' Create Smooth Normals
       gluQuadricTexture(quadObj, %GL_TRUE)     ' Create Texture Coords
       gluCylinder(quadObj, Radius * R1, Radius * R2, Value, 24, 1)
       gluDeleteQuadric(quadObj)
    END IF
END SUB

'// The main exported plugin's function would be bbProc, like this:
FUNCTION BBProc ALIAS "BBProc" (BYREF BBP AS BBPLUGIN) EXPORT AS LONG
    REGISTER K AS LONG

    LOCAL nRet AS LONG

    DIM mt(1 TO 1) AS STATIC BBPTEXTURE
    LOCAL rc AS RECT

'STATIC UseFont AS ZGLFONT

'    STATIC ptr_wglSwapIntervalEXT AS DWORD
    STATIC PulseAngle, rAspect AS SINGLE

    nRet = %BBP_SUCCESS

    SELECT CASE LONG BBP.Msg
    CASE %BBP_RENDER
         '// Draw the scene using BBP.LeftPeak and BBP.RightPeak
         LOCAL nLValue, nRValue, nValue, cbR, cbG, cbB AS LONG
         LOCAL pulse, UseSize, ax, ay AS SINGLE
         LOCAL IncreaseRange, ColorRange, RGBcolor, xStep AS LONG


         nLValue = (BBP.Lpeak / 700)
         nRValue = (BBP.Rpeak / 768)
         nValue = MAX&(nLValue, nRValue)

         '// Pulsating section
         pulse = nValue / 7
         '// Velocity section
         pulse = ABS(pulse / 4)
         
         STATIC TT AS LONG, WasPulse AS SINGLE

         PulseAngle = PulseAngle + pulse: IF PulseAngle > 360 THEN PulseAngle = PulseAngle -360
         IF PulseAngle > 90 AND WasPulse < 90 THEN INCR TT: IF TT > 1 THEN TT = 0 
         IF TT = 0 THEN TT = 1

         WasPulse = PulseAngle 

         DIM pv(128) AS SINGLE ' audio peak value
         FOR K = 0 TO 128
             '// WIM MAGIC!
             '// BBP.WIMdata returns a pointer to an area of memory
             '// containing an array of 256 short integer.
             '// Warning, the Left and Right audio channels are mixed together
             '// thus we step 4, to consider only one channel.
             pv(K) = MAX(PEEK(INTEGER, BBP.WIMdata + K * 4) / 32767, PEEK(INTEGER, BBP.WIMdata + 2 + K * 4) / 32767)
         NEXT

         glClear(%GL_COLOR_BUFFER_BIT OR %GL_DEPTH_BUFFER_BIT)

'RGBcolor = BBP_ColorARGB(255, RGB(20, 20, 148))
'Af$ = str$(s)
'BBP_DrawGLText(BBP.ParentWindow, UseFont, 10, 10, (Af$), RGBcolor)

         glLoadIdentity()
         
         gluLookAt(0.0, 0.0, 15.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0)


         glEnable(%GL_BLEND)
         glDepthMask(%GL_FALSE) ' <------------

         UseSize = 6
         glRotatef(PulseAngle, 0.0, 1.0, 0.0)


         glEnable (%GL_LIGHTING)
         glBindTexture(%GL_TEXTURE_2D, mt(1).Texture)

         FOR K = 0 TO 128 STEP 4
      
             'wData% =  MAX&(PEEK(INTEGER, BBP.WIMdata + K * 4), PEEK(INTEGER, BBP.WIMdata + 2 + K * 4))
             'ColorRange = 32 - (64 - ((wData% + &H7FFF) \ 1074)) 
             'ColorRange = 32 - (64 - ((pv(K) * 32767 + 32767) \ 1074)) 
             ColorRange = 32 - (64 - (pv(K) * 30 + 30)) 
      
             '// Draw burning cylinder
             glPushMatrix()
                IncreaseRange = 0: IF ColorRange > 6 THEN IncreaseRange = 12
                RGBColor = LevelColr(ColorRange + IncreaseRange)
                glColor4ub(BBP_GetRValue(RGBColor), _
                                BBP_GetGValue(RGBColor), _
                                BBP_GetBValue(RGBColor), _
                                255) ' Fading
                glTranslatef(-UseSize + UseSize * K / 64, -1.5, 0)
                glRotatef(-90, 1.0, 0.0, 0.0)
                DrawCylinder(0.75, pv(K) * 8, 1, 0.875)' 1)
             glPopMatrix()
      
             '// Draw ground reflection
             glPushMatrix()
                RGBColor = LevelColr(ColorRange)
                glColor4ub(BBP_GetRValue(RGBColor), _
                                BBP_GetGValue(RGBColor), _
                                BBP_GetBValue(RGBColor), _
                                255) ' Fading
                glTranslatef(-UseSize + UseSize * K / 64, -2.0, 0)
                glRotatef(90, 1.0, 0.0, 0.0)
                ax = 3: ay = pv(K) * 8
                glBegin(%GL_QUADS)
                   glTexCoord2f(0.0, 0.0): glVertex3f(-ax!,-ay!, 0.0)
                   glTexCoord2f(1.0, 0.0): glVertex3f( ax!,-ay!, 0.0)
                   glTexCoord2f(1.0, 1.0): glVertex3f( ax!, ay!, 0.0)
                   glTexCoord2f(0.0, 1.0): glVertex3f(-ax!, ay!, 0.0)
                glEnd()
             glPopMatrix()
      
         NEXT         

         glDepthMask(%GL_TRUE) ' <------------
         glDisable(%GL_BLEND)

         glFlush()

         '// Very important we must reassign UseRC to the new UseDC
         '// Note: don't use permanent DC, this produce better and smoother display
         wglMakeCurrent(BBP.DC, BBP.RC)

    CASE %BBP_CREATE
         '// Retrieve plugin details
         BBP.Title    = "Fahrenheit 451"
         BBP.Author   = "Patrice Terrier"
         BBP.Version  = MAKDWD(1, 0) '// Version 1.0"
         BBP.RenderTo = %BBP_OPENGL  '// or %BBP_GDIPLUS, or %BBP_DIRECTX

    CASE %BBP_INIT
         '// Do your code initialisation there

         '// Set random-number seed.
         RANDOMIZE TIMER

         BBP_SplitColorARGB(BBP.BackARGB, A?, R?, G?, B?)
         Alpha! = A? + 1: Red! = R? + 1: Green! = G? + 1: Blue! = B? + 1
         glClearColor(Red! / 256, Green! /256, Blue! / 256, Alpha! / 256)

         glEnable(%GL_DEPTH_TEST)
         glShadeModel(%GL_SMOOTH)
         glEnable (%GL_LIGHTING)
         glEnable (%GL_LIGHT0)
         glEnable(%GL_COLOR_MATERIAL)
         glColorMaterial (%GL_FRONT_AND_BACK, %GL_AMBIENT_AND_DIFFUSE)
         glEnable(%GL_NORMALIZE)
         glBlendFunc(%GL_ONE, %GL_ONE)

         glEnable(%GL_ALPHA_TEST)                             'Enable Alpha Testing

         glEnable(%GL_TEXTURE_2D)

         mt(1).FullName = $BBP_PLUGIN_FOLDER + "Texture\beam.jpg": mt(1).ID = 1: mt(1).Square = 0
         MakeMultipleTexture (BYVAL VARPTR(mt(LBOUND(mt))), UBOUND(mt) - LBOUND(mt) + 1)

         ColorInit()

    CASE %BBP_SIZE
         '// The size of the view port has changed.
         GetClientRect(BBP.ParentWindow, rc)

         glMatrixMode(%GL_PROJECTION)
         glLoadIdentity()
         rAspect = 0: IF rc.nBottom THEN rAspect = rc.nRight / rc.nBottom
         gluPerspective(35.0, rAspect, 0.1, 150.0)
         glMatrixMode(%GL_MODELVIEW)

    CASE %BBP_DESTROY
         '// Free up your resources there
         DestroyTexture (BYVAL VARPTR(mt(LBOUND(mt))), UBOUND(mt) - LBOUND(mt) + 1)

    CASE ELSE
        nRet = %BBP_ERROR
    END SELECT

    FUNCTION = nRet
END FUNCTION

SUB MakeMultipleTexture (BYVAL tp AS BBPTEXTURE PTR, BYVAL N AS LONG)
    LOCAL mtCount, K, nRet, xSize, ySize, OkDelete AS LONG
    DIM mt(1 TO N) AS BBPTEXTURE AT tp
    mtCount = UBOUND(mt()) - LBOUND(mt()) + 1
    IF mtCount THEN
       DIM Texture(1 TO mtCount) AS LONG
       FOR K = 1 TO mtCount
           Texture(K) = mt(k).Texture: IF Texture(K) THEN OkDelete = -1
       NEXT
       IF OkDelete THEN glDeleteTextures(mtCount, Texture(1))
       glGenTextures(mtCount, Texture(1)): nRet = glGetError()
       IF nRet = 0 THEN
          FOR K = 1 TO mtCount
              REDIM PixelArray(0) AS BYTE
              IF BBP_CreateGLTextureFromFile(mt(K).FullName, xSize, ySize, PixelArray(), mt(K).Square) THEN
                 mt(k).Texture = Texture(K)
                 glBindTexture(%GL_TEXTURE_2D, Texture(K)): nRet = glGetError
                 IF nRet = 0 THEN
                    glTexParameteri(%GL_TEXTURE_2D, %GL_TEXTURE_MAG_FILTER, %GL_LINEAR)
                    glTexParameteri(%GL_TEXTURE_2D, %GL_TEXTURE_MIN_FILTER, %GL_LINEAR)
                    glTexImage2D(%GL_TEXTURE_2D, 0, 4, xSize&, ySize&, 0, %GL_RGBA, %GL_UNSIGNED_BYTE, PixelArray(0))
                 END IF
              END IF
          NEXT
       END IF
    END IF
END SUB

SUB DestroyTexture(BYVAL tp AS BBPTEXTURE PTR, BYVAL N AS LONG) 
    LOCAL K, mtCount, OkDelete AS LONG 
    DIM mt(1 TO N) AS BBPTEXTURE AT tp
    mtCount = UBOUND(mt()) - LBOUND(mt()) + 1
    IF mtCount THEN
       DIM Texture(1 TO mtCount) AS LONG
       FOR K = 1 TO mtCount
           Texture(K) = mt(k).Texture: IF Texture(K) THEN OkDelete = -1
       NEXT
       IF OkDelete THEN glDeleteTextures(mtCount, Texture(1))
    END IF
END SUB
