'+--------------------------------------------------------------------------+
'|                                                                          |
'|                               BBP_Flares                                 |
'|                          BassBox OpenGL plugin                           |
'|                                                                          |
'|                              Version 1.00                                |
'|                                                                          |
'+--------------------------------------------------------------------------+
'|                                                                          |
'|                         Author Patrice TERRIER                           |
'|                                                                          |
'|                            copyright(c) 2007                             |
'|                                                                          |
'|                Patrice Terrier http://www.zapsolution.com                |
'|                                                                          |
'+--------------------------------------------------------------------------+
'|                  Project started on : 10-30-2007 (MM-DD-YYYY)            |
'|                        Last revised : 02-22-2014 (MM-DD-YYYY)            |
'+--------------------------------------------------------------------------+
'
#COMPILE DLL "BBP_Flares.dll"
#INCLUDE "BBPlugin.inc"

'//DECLARE SUB skDebug LIB "SKENGINE.DLL" (BYVAL Msg$)

TYPE RECT
    nLeft AS LONG
    nTop AS LONG
    nRight AS LONG
    nBottom AS LONG
END TYPE

DECLARE FUNCTION GetClientRect LIB "USER32.DLL" ALIAS "GetClientRect" (BYVAL hwnd AS DWORD, lpRect AS RECT) AS LONG

' -- For V-Sync control we need to get address of extensions
DECLARE FUNCTION wglGetProcAddress LIB "opengl32.dll" ALIAS "wglGetProcAddress" (lpStr AS ASCIIZ) AS LONG

' Key State Masks for Mouse Messages
%MK_LBUTTON                     = &H0001
%MK_RBUTTON                     = &H0002
%MK_SHIFT                       = &H0004
%MK_CONTROL                     = &H0008
%MK_MBUTTON                     = &H0010
%MK_XBUTTON1                    = &H0020
%MK_XBUTTON2                    = &H0040

%WM_MOUSEMOVE                   = &H200
%WM_LBUTTONDOWN                 = &H201
%WM_LBUTTONUP                   = &H202
%WM_LBUTTONDBLCLK               = &H203
%WM_RBUTTONDOWN                 = &H204
%WM_RBUTTONUP                   = &H205
%WM_RBUTTONDBLCLK               = &H206
%WM_MBUTTONDOWN                 = &H207
%WM_MBUTTONUP                   = &H208
%WM_MBUTTONDBLCLK               = &H209
%WM_MOUSEWHEEL                  = &H20A
%WM_XBUTTONDOWN                 = &H20B
%WM_XBUTTONUP                   = &H20C
%WM_XBUTTONDBLCLK               = &H20D

%GL_UNSIGNED_BYTE               = &h1401&
%GL_QUADS                       = &h0007&
%GL_COLOR_BUFFER_BIT            = &h4000&
%GL_DEPTH_BUFFER_BIT            = &h0100&
%GL_MATRIX_MODE                 = &h0BA0&
%GL_MODELVIEW                   = &h1700&
%GL_PROJECTION                  = &h1701&
%GL_SMOOTH                      = &h1D01&
%GL_DEPTH_TEST                  = &h0B71&
%GL_SRC_ALPHA                   = &h0302&
%GL_ONE                         = &h0001&
%GL_BLEND                       = &h0BE2&
%GL_LINEAR                      = &h2601&
%GL_PERSPECTIVE_CORRECTION_HINT = &h0C50&
%GL_NICEST                      = &h1102&
%GL_TEXTURE_2D                  = &h0DE1&
%GL_TEXTURE_MAG_FILTER          = &h2800&
%GL_TEXTURE_MIN_FILTER          = &h2801&
%GL_LUMINANCE                   = &h1909&
%GL_RGB                         = &H1907
%GL_RGBA                        = &H1908
%GL_TEXTURE                     = &H1702
%GL_LESS                        = &H0201
%GL_LIGHTING                    = &H0B50
%GL_GREATER                     = &H0204

DECLARE SUB glEnd LIB "opengl32.dll" ALIAS "glEnd"
DECLARE SUB glPushMatrix LIB "opengl32.dll" ALIAS "glPushMatrix"
DECLARE SUB glLoadIdentity LIB "opengl32.dll" ALIAS "glLoadIdentity"
DECLARE SUB glBegin LIB "opengl32.dll" ALIAS "glBegin" (BYVAL LONG)
DECLARE SUB glClear LIB "opengl32.dll" ALIAS "glClear" (BYVAL DWORD)
DECLARE SUB glEnable LIB "opengl32.dll" ALIAS "glEnable" (BYVAL DWORD)
DECLARE SUB glDisable LIB "opengl32.dll" ALIAS "glDisable" (BYVAL DWORD)
DECLARE SUB glClearDepth LIB "opengl32.dll" ALIAS "glClearDepth" (BYVAL DOUBLE)
DECLARE SUB glShadeModel LIB "opengl32.dll" ALIAS "glShadeModel" (BYVAL DWORD)
DECLARE SUB glMatrixMode LIB "opengl32.dll" ALIAS "glMatrixMode" (BYVAL DWORD)
DECLARE SUB glHint LIB "opengl32.dll" ALIAS "glHint" (BYVAL DWORD, BYVAL DWORD)
DECLARE SUB glBlendFunc LIB "opengl32.dll" ALIAS "glBlendFunc" (BYVAL LONG, BYVAL LONG)
DECLARE SUB glTexCoord2f LIB "opengl32.dll" ALIAS "glTexCoord2f" (BYVAL SINGLE, BYVAL SINGLE)
DECLARE SUB glTexEnvi LIB "opengl32.dll" ALIAS "glTexEnvi" (BYVAL DWORD, BYVAL DWORD, BYVAL LONG)
DECLARE SUB glVertex3f LIB "opengl32.dll" ALIAS "glVertex3f" (BYVAL SINGLE, BYVAL SINGLE, BYVAL SINGLE)
DECLARE SUB glTranslatef LIB "opengl32.dll" ALIAS "glTranslatef" (BYVAL SINGLE, BYVAL SINGLE, BYVAL SINGLE)
DECLARE SUB glColor3f LIB "opengl32.dll" ALIAS "glColor3f" (BYVAL SINGLE, BYVAL SINGLE, BYVAL SINGLE)
DECLARE SUB glFrustum LIB "opengl32.dll" ALIAS "glFrustum" (BYVAL DOUBLE, BYVAL DOUBLE, BYVAL DOUBLE, BYVAL DOUBLE, BYVAL DOUBLE, BYVAL DOUBLE)
DECLARE SUB glColor4f LIB "opengl32.dll" ALIAS "glColor4f" (BYVAL SINGLE, BYVAL SINGLE, BYVAL SINGLE, BYVAL SINGLE)
DECLARE SUB glViewport LIB "opengl32.dll" ALIAS "glViewport" (BYVAL LONG, BYVAL LONG, BYVAL LONG, BYVAL LONG)
DECLARE SUB glClearColor LIB "opengl32.dll" ALIAS "glClearColor" (BYVAL SINGLE, BYVAL SINGLE, BYVAL SINGLE, BYVAL SINGLE)
DECLARE SUB glGenTextures LIB "opengl32.dll" ALIAS "glGenTextures" (BYVAL DWORD, textures AS ANY)
DECLARE SUB glBindTexture LIB "opengl32.dll" ALIAS "glBindTexture" (BYVAL DWORD, BYVAL DWORD)
DECLARE SUB glTexParameteri LIB "opengl32.dll" ALIAS "glTexParameteri" (BYVAL DWORD, BYVAL DWORD, BYVAL LONG)
DECLARE SUB glTexImage2D LIB "opengl32.dll" ALIAS "glTexImage2D" (BYVAL DWORD, BYVAL LONG, BYVAL LONG, BYVAL LONG, BYVAL LONG, BYVAL LONG, BYVAL DWORD, BYVAL DWORD, npixels AS ANY)
DECLARE SUB glDeleteTextures LIB "opengl32.dll" ALIAS "glDeleteTextures" (BYVAL LONG, textures AS ANY)
DECLARE FUNCTION glGetError LIB "opengl32.dll" ALIAS "glGetError" () AS DWORD
DECLARE FUNCTION wglMakeCurrent LIB "OPENGL32.DLL" ALIAS "wglMakeCurrent" (BYVAL hdc AS DWORD, BYVAL hglrc AS DWORD) AS LONG
DECLARE SUB gluPerspective LIB "glu32.dll" ALIAS "gluPerspective" (BYVAL fovy#, BYVAL aspect#, BYVAL zNear#, BYVAL zFar AS DOUBLE)
DECLARE SUB glRotatef LIB "OPENGL32.DLL" ALIAS "glRotatef" (BYVAL angle AS SINGLE, BYVAL x AS SINGLE, BYVAL y AS SINGLE, BYVAL z AS SINGLE)
DECLARE SUB glDepthFunc LIB "OPENGL32.DLL" ALIAS "glDepthFunc" (BYVAL func AS DWORD)
DECLARE SUB glAlphaFunc LIB "OPENGL32.DLL" ALIAS "glAlphaFunc" (BYVAL func AS DWORD, BYVAL ref AS SINGLE)

GLOBAL gsR(), gsG(), gsB() AS SINGLE

GLOBAL gColor() AS LONG, gzRegistryPluginCXYZ AS ASCIIZ * 32

' -- Advanced feature to keep vertical sync on
'DECLARE FUNCTION prototype_wglSwapIntervalEXT( BYVAL number AS LONG ) AS LONG

SUB ColorInit()
    DIM gColor(1 TO 33) AS LONG
        
    gColor(1)  = RGB(32,32,32)
    gColor(2)  = RGB(0,44,233)
    gColor(3)  = RGB(0,67,210)
    gColor(4)  = RGB(0,89,187)
    gColor(5)  = RGB(0,112,164)
    gColor(6)  = RGB(0,135,142)
    gColor(7)  = RGB(0,159,117)
    gColor(8)  = RGB(0,183,88)
    gColor(9)  = RGB(0,207,58)
    gColor(10) = RGB(0,231,29)
    gColor(11) = RGB(26,234,26)
    gColor(12) = RGB(52,237,23)
    gColor(13) = RGB(79,240,20)
    gColor(14) = RGB(105,243,17)
    gColor(15) = RGB(126,245,14)
    gColor(16) = RGB(147,248,11)
    gColor(17) = RGB(168,250,8)
    gColor(18) = RGB(189,253,5)
    gColor(19) = RGB(210,255,2)
    gColor(20) = RGB(233,255,0)
    gColor(21) = RGB(255,255,0)
    gColor(22) = RGB(255,251,0)
    gColor(23) = RGB(255,235,0)
    gColor(24) = RGB(255,215,0)
    gColor(25) = RGB(255,196,0)
    gColor(26) = RGB(255,176,0)
    gColor(27) = RGB(255,156,0)
    gColor(28) = RGB(253,137,0)
    gColor(29) = RGB(255,117,0)
    gColor(30) = RGB(255,97,0)
    gColor(31) = RGB(255,78,0)
    gColor(32) = RGB(255,58,0)
    gColor(33) = RGB(255,0,0)
    
END SUB

FUNCTION LevelColr(BYVAL nLevel AS LONG) AS LONG
    LOCAL nColor AS LONG
    nLevel = nLevel + 1: IF nLevel > 33 THEN nLevel = 33
    nColor = 0: IF nLevel > 0 THEN nColor = gColor(nLevel)
    FUNCTION = nColor
END FUNCTION

'// The main exported plugin's function would be bbProc, like this:
FUNCTION BBProc ALIAS "BBProc" (BYREF BBP AS BBPLUGIN) EXPORT AS LONG
    LOCAL x, y, K, KK, nRet, Msg, wParam, lParam AS LONG
    LOCAL sDataString AS STRING, rc AS RECT

    STATIC Mx, My, MDown AS LONG
    STATIC Cx, _        '// Camera rotation
           Cy, _        '// Camera rotation
           Cz _         '// Zoom
           AS SINGLE
'    STATIC ptr_wglSwapIntervalEXT AS DWORD
    DIM mt(1 TO 1) AS STATIC BBPTEXTURE

    nRet = %BBP_SUCCESS

    SELECT CASE LONG BBP.Msg
    CASE %BBP_RENDER
         LOCAL Direction AS LONG, Ax, Bx, Ay, By AS SINGLE
         LOCAL nLValue, nRValue AS DWORD, UseColor AS LONG
         LOCAL R1, G1, B1 AS BYTE, pulse AS DOUBLE
         STATIC PulseAngle AS SINGLE

         nLValue = (BBP.Lpeak / 700)
         nRValue = (BBP.Rpeak / 700)

         pulse = MAX(nLValue, nRValue) / 7
         PulseAngle = (PulseAngle + pulse) MOD 360

         CALL glClear(%GL_COLOR_BUFFER_BIT OR %GL_DEPTH_BUFFER_BIT)

         CALL glLoadIdentity()

         CALL glTranslatef(0.0, 0.0, Cz)

         CALL glrotatef(Cx, 1.0, 1.0, 0.0)
         CALL glrotatef(Cy, 0.0, 1.0, 0.0)

         '// This is where the magic happens:
         '// BBP.FFTsize returns a pointer to an area of memory containing an array of 256 singles.
         '// This is then mapped to the fft() array where it can be accessed.
         DIM fft(BBP.FFTsize) AS SINGLE AT BBP.FFTdata
         DIM SoundBuffer(BBP.FFTsize) AS SINGLE

         '// Try and smooth out the buffer by averaging the last results:
         FOR K = 0 TO 32 ' 255
             '// We use SQR to bring out the midtone of the music, otherwise the spectrum is very flat.
             '// And fortunatly SQR is highy optimized in PowerBASIC
             SoundBuffer(K) = SQR(SQR(fft(K)) * 2)
         NEXT

         CALL glBindTexture(%GL_TEXTURE_2D, mt(1).Texture)
         FOR Direction = -1 TO 1
             IF Direction THEN
                FOR KK = 0 TO 2
                    K = KK * 16
                    CALL glPushMatrix()
                    '// The iterator K goes from 0 (deepest bass) to 255 (highest treble pitch)
                    '// Ax is the distance from the center. Ay & By are width and height of the flares.
                    Ax = (KK * 16) / 64 * 125 * Direction

                    Ay = 2 + SoundBuffer(K) * (50 + K / 255 * 70) '// As K increases, the relative size of the signal
                    By = 2 + SoundBuffer(K) * (50 + K / 255 * 70) '// drops, so the (K / 255 * 20) compensates by boosting the signal at higher frequencies.

                    CALL glColor4f(gsR(K) * SoundBuffer(K), gsG(K) * SoundBuffer(K), gsB(K) * SoundBuffer(K) + 0.1, 0.7)
                    CALL glTranslatef(Ax, 0.0, 0.0)
                    CALL glrotatef(Cx, 1, 0, 0)
                    CALL glrotatef(Cy, 0, 1, 0)

                    CALL glBegin(%GL_QUADS)
                         CALL glTexCoord2f(0,0): CALL glVertex3f(-By , Ay, 0.0)
                         CALL glTexCoord2f(1,0): CALL glVertex3f( By , Ay, 0.0)
                         CALL glTexCoord2f(1,1): CALL glVertex3f( By ,-Ay, 0.0)
                         CALL glTexCoord2f(0,1): CALL glVertex3f(-By ,-Ay, 0.0)
                    CALL glEnd()

                    CALL glPopMatrix()
                NEXT
             END IF
         NEXT

         '// Very important we must reassign BBP.RC to the new BBP.DC
         '// Note: don't use permanent DC, this produce better and smoother display
         CALL wglMakeCurrent(BBP.DC, BBP.RC)

    CASE %BBP_CREATE
         '// Retrieve plugin details
         BBP.Title    = "Flares"
         BBP.Author   = "Patrice Terrier"
         BBP.Version  = MAKDWD(1, 0) '// Version 1.0"
         BBP.RenderTo = %BBP_OPENGL  '// or %BBP_GDIPLUS, or %BBP_DIRECTX
         gzRegistryPluginCXYZ = $RegistryPluginCXYZ + BBP.Title

    CASE %BBP_INIT
'         '// May I ask you at which pretty pointer wglSwapIntervalEXT situated is ?
'         ptr_wglSwapIntervalEXT = wglGetProcAddress("wglSwapIntervalEXT")

         '// Do your code initialisation there
         CALL ColorInit()

         '// Set random-number seed.
         RANDOMIZE TIMER

         CALL BBP_SplitColorARGB(BBP.BackARGB, A?, R?, G?, B?)
         Alpha! = A? + 1: Red! = R? + 1: Green! = G? + 1: Blue! = B? + 1
         CALL glClearColor(Red! / 256, Green! /256, Blue! / 256, Alpha! / 256)

         CALL glShadeModel(%GL_SMOOTH) '// Enables Smooth Color Shading
         CALL glClearDepth(1.0)        '// Depth Buffer Setup

         CALL glDisable(%GL_DEPTH_TEST)'// Disable Depth Buffer

         '**'CALL glBlendFunc(%GL_SRC_ALPHA, %GL_ONE)
         CALL glBlendFunc(%GL_ONE, %GL_ONE)

         CALL glDepthFunc(%GL_LESS)    '// The Type Of Depth Test To Do

         CALL glDisable(%GL_LIGHTING)

         CALL glEnable(%GL_BLEND)
                 
         CALL glAlphaFunc(%GL_GREATER, 0.01)

         CALL glHint(%GL_PERSPECTIVE_CORRECTION_HINT, %GL_NICEST)

         CALL glEnable(%GL_TEXTURE_2D)

         mt(1).FullName = $BBP_PLUGIN_FOLDER + "Texture\Flares.png": mt(1).ID = 1: mt(1).Square = 0
         'mt(1).FullName = $BBP_PLUGIN_FOLDER + "Texture\Flare0.jpg": mt(1).ID = 1: mt(1).Square = 0
         CALL MakeMultipleTexture (BYVAL VARPTR(mt(LBOUND(mt))), UBOUND(mt) - LBOUND(mt) + 1)

         CALL MakeColorLUT()

'        // Setup CX, CY, CZ
         Cx = -717: Cy = -994: Cz = -71


    CASE %BBP_SIZE
         '// The size of the view port has changed.
         LOCAL rAspect AS DOUBLE
         CALL GetClientRect(BBP.ParentWindow, rc)

         CALL glMatrixMode(%GL_PROJECTION)
         CALL glLoadIdentity()
         rAspect = 0: IF rc.nBottom THEN rAspect = rc.nRight / rc.nBottom
         CALL gluPerspective(50.0, rAspect, 0.01, 5000.0)
         CALL glMatrixMode(%GL_MODELVIEW)

    CASE %BBP_MOUSE

    CASE %BBP_KEYBOARD
    
    CASE %BBP_DESTROY
         
         '// Free up your resources there
         CALL DestroyTexture (BYVAL VARPTR(mt(LBOUND(mt))), UBOUND(mt) - LBOUND(mt) + 1)

    CASE ELSE
        nRet = %BBP_ERROR
    END SELECT
    FUNCTION = nRet

END FUNCTION

SUB MakeColorLUT()
    LOCAL K, RGBColor AS LONG
    DIM gsR(255), gsG(255), gsB(255) AS SINGLE
    FOR K = 0 TO 255
        RGBColor = LevelColr(K)
        gsR(K) = (BBP_GetRValue(RGBColor) + 1) / 256
        gsG(K) = (BBP_GetGValue(RGBColor) + 1) / 256
        gsB(K) = (BBP_GetBValue(RGBColor) + 1) / 256
    NEXT

    'LOCAL sa, sb, sc AS SINGLE
    'sa = RND: sb = RND: sc = RND
    'FOR K = 0 TO 255
    '    gsR(K) = SIN((K / 255 + sa) * 3.141592) * 0.5 + 0.5
    '    gsG(K) = SIN((K / 255 + sb) * 3.141592) * 0.5 + 0.5
    '    gsB(K) = SIN((K / 255 + sc) * 3.141592) * 0.5 + 0.5
    'NEXT
END SUB

SUB MakeMultipleTexture (BYVAL tp AS BBPTEXTURE PTR, BYVAL N AS LONG)
    LOCAL mtCount, K, nRet, xSize, ySize, OkDelete AS LONG
    DIM mt(1 TO N) AS BBPTEXTURE AT tp
    mtCount = UBOUND(mt()) - LBOUND(mt()) + 1
    IF mtCount THEN
       DIM Texture(1 TO mtCount) AS LONG
       FOR K = 1 TO mtCount
           Texture(K) = mt(k).Texture: IF Texture(K) THEN OkDelete = -1
       NEXT
       IF OkDelete THEN CALL glDeleteTextures(mtCount, Texture(1))
       CALL glGenTextures(mtCount, Texture(1)): nRet = glGetError()
       IF nRet = 0 THEN
          FOR K = 1 TO mtCount
              REDIM PixelArray(0) AS BYTE
              IF BBP_CreateGLTextureFromFile(mt(K).FullName, xSize, ySize, PixelArray(), mt(K).Square) THEN
                 mt(k).Texture = Texture(K)
                 CALL glBindTexture(%GL_TEXTURE_2D, Texture(K)): nRet = glGetError
                 IF nRet = 0 THEN
                    CALL glTexParameteri(%GL_TEXTURE_2D, %GL_TEXTURE_MAG_FILTER, %GL_LINEAR)
                    CALL glTexParameteri(%GL_TEXTURE_2D, %GL_TEXTURE_MIN_FILTER, %GL_LINEAR)
                    CALL glTexImage2D(%GL_TEXTURE_2D, 0, 4, xSize&, ySize&, 0, %GL_RGBA, %GL_UNSIGNED_BYTE, PixelArray(0))
                 END IF
              END IF
          NEXT
       END IF
    END IF
END SUB

SUB DestroyTexture(BYVAL tp AS BBPTEXTURE PTR, BYVAL N AS LONG) 
    LOCAL K, mtCount, OkDelete AS LONG 
    DIM mt(1 TO N) AS BBPTEXTURE AT tp
    mtCount = UBOUND(mt()) - LBOUND(mt()) + 1
    IF mtCount THEN
       DIM Texture(1 TO mtCount) AS LONG
       FOR K = 1 TO mtCount
           Texture(K) = mt(k).Texture: IF Texture(K) THEN OkDelete = -1
       NEXT
       IF OkDelete THEN CALL glDeleteTextures(mtCount, Texture(1))
    END IF
END SUB
