'+--------------------------------------------------------------------------+
'|                                                                          |
'|                                Impulse                                   |
'|                          BassBox OpenGL plugin                           |
'|                                                                          |
'|                              Version 1.00                                |
'|                                                                          |
'+--------------------------------------------------------------------------+
'|                                                                          |
'|                         Author Patrice TERRIER                           |
'|                                                                          |
'|                            copyright(c) 2007                             |
'|                                                                          |
'|                Patrice Terrier http://www.zapsolution.com                |
'|                                                                          |
'+--------------------------------------------------------------------------+
'|                  Project started on : 12-09-2007 (MM-DD-YYYY)            |
'|                        Last revised : 12-09-2007 (MM-DD-YYYY)            |
'+--------------------------------------------------------------------------+
'
#COMPILE DLL "BBP_Impulse.dll"
#INCLUDE "BBPlugin.inc"

'//DECLARE SUB skDebug LIB "SKENGINE.DLL" (BYVAL Msg$)

TYPE RECT
    nLeft AS LONG
    nTop AS LONG
    nRight AS LONG
    nBottom AS LONG
END TYPE

DECLARE FUNCTION GetClientRect LIB "USER32.DLL" ALIAS "GetClientRect" (BYVAL hwnd AS DWORD, lpRect AS RECT) AS LONG

' -- For V-Sync control we need to get address of extensions
DECLARE FUNCTION wglGetProcAddress LIB "opengl32.dll" ALIAS "wglGetProcAddress" (lpStr AS ASCIIZ) AS LONG

' Key State Masks for Mouse Messages
%MK_LBUTTON                     = &H0001
%MK_RBUTTON                     = &H0002
%MK_SHIFT                       = &H0004
%MK_CONTROL                     = &H0008
%MK_MBUTTON                     = &H0010
%MK_XBUTTON1                    = &H0020
%MK_XBUTTON2                    = &H0040

%WM_MOUSEMOVE                   = &H200
%WM_LBUTTONDOWN                 = &H201
%WM_LBUTTONUP                   = &H202
%WM_LBUTTONDBLCLK               = &H203
%WM_RBUTTONDOWN                 = &H204
%WM_RBUTTONUP                   = &H205
%WM_RBUTTONDBLCLK               = &H206
%WM_MBUTTONDOWN                 = &H207
%WM_MBUTTONUP                   = &H208
%WM_MBUTTONDBLCLK               = &H209
%WM_MOUSEWHEEL                  = &H20A
%WM_XBUTTONDOWN                 = &H20B
%WM_XBUTTONUP                   = &H20C
%WM_XBUTTONDBLCLK               = &H20D

%GL_UNSIGNED_BYTE               = &h1401&
%GL_QUADS                       = &h0007&
%GL_COLOR_BUFFER_BIT            = &h4000&
%GL_DEPTH_BUFFER_BIT            = &h0100&
%GL_MATRIX_MODE                 = &h0BA0&
%GL_MODELVIEW                   = &h1700&
%GL_PROJECTION                  = &h1701&
%GL_SMOOTH                      = &h1D01&
%GL_DEPTH_TEST                  = &h0B71&
%GL_SRC_ALPHA                   = &h0302&
%GL_ONE                         = &h0001&
%GL_BLEND                       = &h0BE2&
%GL_LINEAR                      = &h2601&
%GL_PERSPECTIVE_CORRECTION_HINT = &h0C50&
%GL_NICEST                      = &h1102&
%GL_TEXTURE_2D                  = &h0DE1&
%GL_TEXTURE_MAG_FILTER          = &h2800&
%GL_TEXTURE_MIN_FILTER          = &h2801&
%GL_LUMINANCE                   = &h1909&
%GL_RGB                         = &H1907
%GL_RGBA                        = &H1908
%GL_TEXTURE                     = &H1702
%GL_LESS                        = &H0201
%GL_LIGHTING                    = &H0B50
%GL_GREATER                     = &H0204
%GL_LEQUAL                      = &H0203
%GL_COMPILE                     = &H1300
%GL_TRIANGLE_STRIP              = &H0005
%GL_POINTS                      = &H0000
%GL_LINES                       = &H0001???

%GL_LIGHT0                      = &H4000???
%GL_COLOR_MATERIAL              = &H0B57???

%GL_POINT_SPRITE                                     = &H08861
%GL_COORD_REPLACE                                    = &H08862

DECLARE SUB glEnd LIB "opengl32.dll" ALIAS "glEnd"
DECLARE SUB glPushMatrix LIB "opengl32.dll" ALIAS "glPushMatrix"
DECLARE SUB glLoadIdentity LIB "opengl32.dll" ALIAS "glLoadIdentity"
DECLARE SUB glBegin LIB "opengl32.dll" ALIAS "glBegin" (BYVAL LONG)
DECLARE SUB glClear LIB "opengl32.dll" ALIAS "glClear" (BYVAL DWORD)
DECLARE SUB glEnable LIB "opengl32.dll" ALIAS "glEnable" (BYVAL DWORD)
DECLARE SUB glDisable LIB "opengl32.dll" ALIAS "glDisable" (BYVAL DWORD)
DECLARE SUB glClearDepth LIB "opengl32.dll" ALIAS "glClearDepth" (BYVAL DOUBLE)
DECLARE SUB glShadeModel LIB "opengl32.dll" ALIAS "glShadeModel" (BYVAL DWORD)
DECLARE SUB glMatrixMode LIB "opengl32.dll" ALIAS "glMatrixMode" (BYVAL DWORD)
DECLARE SUB glHint LIB "opengl32.dll" ALIAS "glHint" (BYVAL DWORD, BYVAL DWORD)
DECLARE SUB glBlendFunc LIB "opengl32.dll" ALIAS "glBlendFunc" (BYVAL LONG, BYVAL LONG)
DECLARE SUB glTexCoord2f LIB "opengl32.dll" ALIAS "glTexCoord2f" (BYVAL SINGLE, BYVAL SINGLE)
DECLARE SUB glTexEnvi LIB "opengl32.dll" ALIAS "glTexEnvi" (BYVAL DWORD, BYVAL DWORD, BYVAL LONG)
DECLARE SUB glVertex3f LIB "opengl32.dll" ALIAS "glVertex3f" (BYVAL SINGLE, BYVAL SINGLE, BYVAL SINGLE)
DECLARE SUB glTranslatef LIB "opengl32.dll" ALIAS "glTranslatef" (BYVAL SINGLE, BYVAL SINGLE, BYVAL SINGLE)
DECLARE SUB glColor3f LIB "opengl32.dll" ALIAS "glColor3f" (BYVAL SINGLE, BYVAL SINGLE, BYVAL SINGLE)
DECLARE SUB glFrustum LIB "opengl32.dll" ALIAS "glFrustum" (BYVAL DOUBLE, BYVAL DOUBLE, BYVAL DOUBLE, BYVAL DOUBLE, BYVAL DOUBLE, BYVAL DOUBLE)
DECLARE SUB glColor4f LIB "opengl32.dll" ALIAS "glColor4f" (BYVAL SINGLE, BYVAL SINGLE, BYVAL SINGLE, BYVAL SINGLE)
DECLARE SUB glViewport LIB "opengl32.dll" ALIAS "glViewport" (BYVAL LONG, BYVAL LONG, BYVAL LONG, BYVAL LONG)
DECLARE SUB glClearColor LIB "opengl32.dll" ALIAS "glClearColor" (BYVAL SINGLE, BYVAL SINGLE, BYVAL SINGLE, BYVAL SINGLE)
DECLARE SUB glGenTextures LIB "opengl32.dll" ALIAS "glGenTextures" (BYVAL DWORD, textures AS ANY)
DECLARE SUB glBindTexture LIB "opengl32.dll" ALIAS "glBindTexture" (BYVAL DWORD, BYVAL DWORD)
DECLARE SUB glTexParameteri LIB "opengl32.dll" ALIAS "glTexParameteri" (BYVAL DWORD, BYVAL DWORD, BYVAL LONG)
DECLARE SUB glTexImage2D LIB "opengl32.dll" ALIAS "glTexImage2D" (BYVAL DWORD, BYVAL LONG, BYVAL LONG, BYVAL LONG, BYVAL LONG, BYVAL LONG, BYVAL DWORD, BYVAL DWORD, npixels AS ANY)
DECLARE FUNCTION glGetError LIB "opengl32.dll" ALIAS "glGetError" () AS DWORD
DECLARE FUNCTION wglMakeCurrent LIB "OPENGL32.DLL" ALIAS "wglMakeCurrent" (BYVAL hdc AS DWORD, BYVAL hglrc AS DWORD) AS LONG
DECLARE SUB gluPerspective LIB "glu32.dll" ALIAS "gluPerspective" (BYVAL fovy#, BYVAL aspect#, BYVAL zNear#, BYVAL zFar AS DOUBLE)
DECLARE SUB glRotatef LIB "OPENGL32.DLL" ALIAS "glRotatef" (BYVAL angle AS SINGLE, BYVAL x AS SINGLE, BYVAL y AS SINGLE, BYVAL z AS SINGLE)
DECLARE SUB glDepthFunc LIB "OPENGL32.DLL" ALIAS "glDepthFunc" (BYVAL func AS DWORD)
DECLARE SUB glAlphaFunc LIB "OPENGL32.DLL" ALIAS "glAlphaFunc" (BYVAL func AS DWORD, BYVAL ref AS SINGLE)
DECLARE SUB glCallList LIB "opengl32.dll" ALIAS "glCallList" (BYVAL list AS DWORD)
DECLARE SUB glNewList LIB "opengl32.dll" ALIAS "glNewList" (BYVAL list AS DWORD, BYVAL mode AS DWORD)
DECLARE SUB glEndList LIB "opengl32.dll" ALIAS "glEndList" ()
DECLARE SUB glColor4ub LIB "OPENGL32.DLL" ALIAS "glColor4ub" (BYVAL red AS BYTE, BYVAL green AS BYTE, BYVAL blue AS BYTE, BYVAL alpha AS BYTE)
DECLARE SUB glPointSize LIB "opengl32.dll" ALIAS "glPointSize" (BYVAL lsize AS SINGLE)
DECLARE SUB glLineWidth LIB "OPENGL32.DLL" ALIAS "glLineWidth" (BYVAL nWidth AS SINGLE)
DECLARE SUB glFlush LIB "OPENGL32.DLL" ALIAS "glFlush" ()
DECLARE FUNCTION glGenLists LIB "opengl32.dll" ALIAS "glGenLists" (BYVAL range&) AS DWORD
DECLARE SUB glDeleteTextures LIB "opengl32.dll" ALIAS "glDeleteTextures" (BYVAL n&, textures AS ANY)

DECLARE SUB gluLookAt LIB "glu32.dll" ALIAS "gluLookAt" (BYVAL eyex#, BYVAL eyey#, BYVAL eyez#, BYVAL centerx#, BYVAL centery#, BYVAL centerz#, BYVAL upx#, BYVAL upy#, BYVAL upz AS DOUBLE)
DECLARE SUB gluCylinder LIB "glu32.dll" ALIAS "gluCylinder" (BYVAL qobj AS DWORD, BYVAL baseRadius#, BYVAL topRadius#, BYVAL nheight#, BYVAL slices&, BYVAL stacks AS LONG)


GLOBAL gsR(), gsG(), gsB() AS SINGLE
GLOBAL gColor() AS LONG', gzRegistryPluginCXYZ AS ASCIIZ * 64

DECLARE FUNCTION GetTickCount LIB "KERNEL32.DLL" ALIAS "GetTickCount" () AS DWORD

' -- Advanced feature to keep vertical sync on
DECLARE FUNCTION prototype_wglSwapIntervalEXT( BYVAL number AS LONG ) AS LONG

SUB ColorInit()
    DIM gColor(1 TO 33) AS LONG
    gColor(1)  = RGB(32,32,32)
    gColor(2)  = RGB(0,44,233)
    gColor(3)  = RGB(0,67,210)
    gColor(4)  = RGB(0,89,187)
    gColor(5)  = RGB(0,112,164)
    gColor(6)  = RGB(0,135,142)
    gColor(7)  = RGB(0,159,117)
    gColor(8)  = RGB(0,183,88)
    gColor(9)  = RGB(0,207,58)
    gColor(10) = RGB(0,231,29)
    gColor(11) = RGB(26,234,26)
    gColor(12) = RGB(52,237,23)
    gColor(13) = RGB(79,240,20)
    gColor(14) = RGB(105,243,17)
    gColor(15) = RGB(126,245,14)
    gColor(16) = RGB(147,248,11)
    gColor(17) = RGB(168,250,8)
    gColor(18) = RGB(189,253,5)
    gColor(19) = RGB(210,255,2)
    gColor(20) = RGB(233,255,0)
    gColor(21) = RGB(255,255,0)
    gColor(22) = RGB(255,251,0)
    gColor(23) = RGB(255,235,0)
    gColor(24) = RGB(255,215,0)
    gColor(25) = RGB(255,196,0)
    gColor(26) = RGB(255,176,0)
    gColor(27) = RGB(255,156,0)
    gColor(28) = RGB(253,137,0)
    gColor(29) = RGB(255,117,0)
    gColor(30) = RGB(255,97,0)
    gColor(31) = RGB(255,78,0)
    gColor(32) = RGB(255,58,0)
    gColor(33) = RGB(255,0,0)
END SUB

FUNCTION LevelColr(BYVAL nLevel AS LONG) AS LONG
    LOCAL nColor AS LONG
    nLevel = nLevel + 1: IF nLevel > 33 THEN nLevel = 33
    nColor = 0: IF nLevel > 0 THEN nColor = gColor(nLevel)
    FUNCTION = nColor
END FUNCTION

SUB setGLPerspective(fovy  AS SINGLE, nAspect AS SINGLE,_
                     zNear AS SINGLE, zFar    AS SINGLE)
    LOCAL xmin!, xmax!, ymin!, ymax!
    ymax =  zNear * TAN(fovy * 0.00872664626)
    ymin = -ymax
    xmin =  ymin * nAspect
    xmax =  ymax * nAspect
    glFrustum(xmin, xmax, ymin, ymax, zNear, zFar)
END SUB

SUB MakeColorLUT()
    LOCAL K, RGBColor AS LONG
    DIM gsR(255), gsG(255), gsB(255) AS SINGLE
    FOR K = 0 TO 255
        RGBColor = LevelColr(K)
        gsR(K) = (BBP_GetRValue(RGBColor) + 1) / 256
        gsG(K) = (BBP_GetGValue(RGBColor) + 1) / 256
        gsB(K) = (BBP_GetBValue(RGBColor) + 1) / 256
    NEXT
END SUB

DECLARE FUNCTION gluNewQuadric  LIB "glu32.dll" ALIAS "gluNewQuadric"  () AS LONG
DECLARE SUB gluDeleteQuadric    LIB "glu32.dll" ALIAS "gluDeleteQuadric"   (BYVAL nState AS DWORD)
DECLARE SUB gluQuadricNormals   LIB "glu32.dll" ALIAS "gluQuadricNormals"  (BYVAL quadObject AS DWORD, BYVAL normals AS DWORD)
DECLARE SUB gluQuadricTexture   LIB "glu32.dll" ALIAS "gluQuadricTexture"  (BYVAL quadObject AS DWORD, BYVAL textureCoords AS DWORD)' ANY)
%GL_TRUE                        = 1
%GLU_SMOOTH                     = 100000

SUB DrawCylinder(BYVAL Radius AS SINGLE, BYVAL Value AS SINGLE)
    LOCAL quadObj AS LONG
    quadObj = gluNewQuadric()                        ' Pointer to the Quadric Object (Return 0 If No Memory))
    IF quadObj THEN
       gluQuadricNormals(quadObj, %GLU_SMOOTH)  ' Create Smooth Normals
       gluQuadricTexture(quadObj, %GL_TRUE)     ' Create Texture Coords
       gluCylinder(quadObj, Radius, Radius, Value, 32, 1)
       gluDeleteQuadric(quadObj)
    END IF
END SUB

SUB UseGLPolarView(BYVAL radius AS SINGLE, BYVAL twist AS SINGLE, BYVAL latitude AS SINGLE, BYVAL longitude AS SINGLE)
    glTranslatef(0.0, 0.0, -radius)
    glRotatef(-twist, 0.0, 0.0, 1.0)
    glRotatef(-latitude, 1.0, 0.0, 0.0)
    glRotatef(longitude, 0.0, 0.0, 1.0)
END SUB

'// Renders flat square
SUB RenderSquare(BYVAL edge AS SINGLE)
    edge = edge / 2
    glBegin(%GL_QUADS)
       glTexCoord2f(0.0, 0.0): glVertex3f(-edge,-edge, 0.0)
       glTexCoord2f(1.0, 0.0): glVertex3f( edge,-edge, 0.0)
       glTexCoord2f(1.0, 1.0): glVertex3f( edge, edge, 0.0)
       glTexCoord2f(0.0, 1.0): glVertex3f(-edge, edge, 0.0)
    glEnd()
END SUB

FUNCTION BBProc ALIAS "BBProc" (BYREF BBP AS BBPLUGIN) EXPORT AS LONG

    LOCAL K, nRet, x, y, Done, Msg, wParam, lParam AS LONG, rc AS RECT, sBuf AS STRING
    LOCAL rAspect AS SINGLE

    STATIC Mx, My, MDown AS LONG
    STATIC UseFont AS ZGLFONT

    STATIC PulseAngle AS SINGLE

    DIM mt(1 TO 2) AS STATIC BBPTEXTURE

    nRet = %BBP_SUCCESS
    SELECT CASE LONG BBP.Msg
    CASE %BBP_RENDER
         LOCAL nLValue, nRValue, nValue, RGBColor AS LONG
         LOCAL pulse AS DOUBLE
         LOCAL cbA, cbR, cbG, cbB AS BYTE
         LOCAL KK, I, Direction AS LONG, Ax, Ay, Cz AS SINGLE
    
         nLValue = (BBP.Lpeak / 700)
         nRValue = (BBP.Rpeak / 700)
         nValue = MAX&(nLValue, nRValue)

         '// Pulsating section
         pulse = nValue / 7
         
         Cz = -55

         '// Velocity section
         pulse = ABS(pulse / 4)
         PulseAngle = (PulseAngle + pulse) MOD 360
    
         RGBColor = LevelColr(nValue)
         cbR = BBP_GetRValue(RGBColor)
         cbG = BBP_GetGValue(RGBColor)
         cbB = BBP_GetBValue(RGBColor)

         glClear(%GL_COLOR_BUFFER_BIT OR %GL_DEPTH_BUFFER_BIT)

         '// This is where the magic happens:
         '// BBP.FFTsize returns a pointer to an area of memory containing an array of 256 singles.
         '// This is then mapped to the fft() array where it can be accessed.
         DIM fft(BBP.FFTsize) AS SINGLE AT BBP.FFTdata
         DIM SoundBuffer(BBP.FFTsize) AS SINGLE

         '// Try and smooth out the buffer by averaging the last results:
         FOR K = 0 TO 255
             '// We use SQR to bring out the midtone of the music, otherwise the spectrum is very flat.
             '// And fortunatly SQR is highy optimized in PowerBASIC
             SoundBuffer(K) = SQR( SQR(fft(K)) * 2)
         NEXT

         FOR Direction = -1 TO 1
             IF Direction THEN
                FOR KK = 0 TO 32
                    K = KK + 1

                    glLoadIdentity()

                    glBindTexture(%GL_TEXTURE_2D, mt(1).Texture)
                    glTranslatef(0.0, -3.45 + 0.95, Cz)
                    glRotatef(-90, 1.0, 0.0, 0.0)
                       '// The iterator K goes from 0 (deepest bass) to 255 (highest treble pitch)
                       '// Ax is the distance from the center. Ay & By are width and height of the flares.
                       Ax = ((KK * 1) / 255 * 18 * Direction)'
                       Ay = 2 + SoundBuffer(K) * 3.5
                       glColor4f(gsR(K) * SoundBuffer(K), gsG(K) * SoundBuffer(K), gsB(K) * SoundBuffer(K) + 0.1, 0.7)
                       glTranslatef(Ax, -2.0, 0.50)
                       I = KK + 1
                       glRotatef(I + (GetTickCount * pulse) / (pulse * I), 0.0, 0.0, 1.0)
                       DrawCylinder(.0625, Ay -0.95)

                    glLoadIdentity()

                    glBindTexture(%GL_TEXTURE_2D, mt(2).Texture)

                       glTranslatef(Ax, 3.25, Cz)
                       RenderSquare((Ay / 5) / 2)

                NEXT
             END IF
         NEXT

         '// Very important we must reassign BBP.RC to the new BBP.DC
         '// Note: don't use permanent DC, this produce better and smoother display
         wglMakeCurrent(BBP.DC, BBP.RC)
         
         glFlush()

    CASE %BBP_CREATE
         '// Retrieve plugin details
         BBP.Title    = "Impulse"
         BBP.Author   = "Patrice Terrier"
         BBP.Version  = MAKDWD(1, 0) '// Version 1.0"
         BBP.RenderTo = %BBP_OPENGL    '// or %BBP_GDIPLUS, or %BBP_DIRECTX

    CASE %BBP_INIT
         '// Do your code initialisation there
         ColorInit()

         BBP_SplitColorARGB(BBP.BackARGB, A?, R?, G?, B?)
         Alpha! = A? + 1: Red! = R? + 1: Green! = G? + 1: Blue! = B? + 1
         glClearColor(Red! / 256, Green! /256, Blue! / 256, Alpha! / 256)

         glShadeModel(%GL_SMOOTH)
         glClearDepth(1.0)        '// Depth Buffer Setup
         glBlendFunc(%GL_ONE, %GL_ONE)
         glDepthFunc(%GL_LESS)    '// The Type Of Depth Test To Do
         glDisable(%GL_LIGHTING)
         glEnable(%GL_BLEND)
         glAlphaFunc(%GL_GREATER, 0.01)
         glHint(%GL_PERSPECTIVE_CORRECTION_HINT, %GL_NICEST)

         glEnable(%GL_TEXTURE_2D)

         RANDOMIZE GetTickCount()

         mt(1).FullName = $BBP_PLUGIN_FOLDER + "Texture\Impulse.jpg":  mt(1).ID = 1: mt(1).Square = 0
         mt(2).FullName = $BBP_PLUGIN_FOLDER + "Texture\Flare0.jpg":  mt(2).ID = 2: mt(2).Square = 0
         MakeMultipleTexture (BYVAL VARPTR(mt(LBOUND(mt))), UBOUND(mt) - LBOUND(mt) + 1)

         MakeColorLUT()

    CASE %BBP_SIZE
         '// The size of the view port has changed.
         GetClientRect(BBP.ParentWindow, rc)
         glMatrixMode(%GL_PROJECTION)
         glLoadIdentity()
         rAspect = 0: IF rc.nBottom THEN rAspect = rc.nRight / rc.nBottom
         setGLPerspective(7.5, rAspect, 1.0, 100.0)
         'gluPerspective(45.0, rAspect, 3.0, 7.0)

         glMatrixMode(%GL_MODELVIEW)

    CASE %BBP_KEYBOARD

    CASE %BBP_MOUSE


    CASE %BBP_DESTROY
         '// Free up your resources there
         DestroyTexture (BYVAL VARPTR(mt(LBOUND(mt))), UBOUND(mt) - LBOUND(mt) + 1)

         'BBP_DeleteGLFont(UseFont) ' Free up the OpenGL font
   
    CASE ELSE
        nRet = %BBP_ERROR
    END SELECT

    FUNCTION = nRet

END FUNCTION

SUB MakeMultipleTexture (BYVAL tp AS BBPTEXTURE PTR, BYVAL N AS LONG)
    LOCAL mtCount, K, nRet, xSize, ySize, OkDelete AS LONG
    DIM mt(1 TO N) AS BBPTEXTURE AT tp
    mtCount = UBOUND(mt()) - LBOUND(mt()) + 1
    IF mtCount THEN
       DIM Texture(1 TO mtCount) AS LONG
       FOR K = 1 TO mtCount
           Texture(K) = mt(k).Texture: IF Texture(K) THEN OkDelete = -1
       NEXT
       IF OkDelete THEN glDeleteTextures(mtCount, Texture(1))
       glGenTextures(mtCount, Texture(1)): nRet = glGetError()
       IF nRet = 0 THEN
          FOR K = 1 TO mtCount
              REDIM PixelArray(0) AS BYTE
              IF BBP_CreateGLTextureFromFile(mt(K).FullName, xSize, ySize, PixelArray(), mt(K).Square) THEN
                 mt(k).Texture = Texture(K)
                 glBindTexture(%GL_TEXTURE_2D, Texture(K)): nRet = glGetError
                 IF nRet = 0 THEN
                    glTexParameteri(%GL_TEXTURE_2D, %GL_TEXTURE_MAG_FILTER, %GL_LINEAR)
                    glTexParameteri(%GL_TEXTURE_2D, %GL_TEXTURE_MIN_FILTER, %GL_LINEAR)
                    glTexImage2D(%GL_TEXTURE_2D, 0, 4, xSize&, ySize&, 0, %GL_RGBA, %GL_UNSIGNED_BYTE, PixelArray(0))
                 END IF
              END IF
          NEXT
       END IF
    END IF
END SUB

SUB DestroyTexture(BYVAL tp AS BBPTEXTURE PTR, BYVAL N AS LONG) 
    LOCAL K, mtCount, OkDelete AS LONG 
    DIM mt(1 TO N) AS BBPTEXTURE AT tp
    mtCount = UBOUND(mt()) - LBOUND(mt()) + 1
    IF mtCount THEN
       DIM Texture(1 TO mtCount) AS LONG
       FOR K = 1 TO mtCount
           Texture(K) = mt(k).Texture: IF Texture(K) THEN OkDelete = -1
       NEXT
       IF OkDelete THEN glDeleteTextures(mtCount, Texture(1))
    END IF
END SUB
